<template>
    <div v-if="currentUser.can_raise_forms" class="flex justify-end p-2 mb-1">
  <Link href="/form/raisedForm/create" class="font-medium text-lime-500 hover:text-lime-600">
    <button class="btn bg-blue-700 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-blue-800 focus:outline-none focus:ring-2 focus:ring-blue-500">
      Raise Form
    </button>
  </Link>
</div>
    <div class="relative shadow-md sm:rounded-lg w-[90vw] md:w-full">
        
        <div class="overflow-auto">
            <table class="w-full table-fixed text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
                <thead class="text-xs text-gray-700 uppercase bg-white dark:bg-gray-700 dark:text-gray-400">
                    <tr class="bg-gray-200 text-black">
                        <th scope="col" class="p-4 w-16" v-if="currentUser.role.delete_raised_form">
                            <button id="dropdownDefaultButton" data-dropdown-toggle="dropdown-table" type="button"
                                data-dropdown-placement="bottom-start" data-dropdown-offset-distance="16"
                                data-dropdown-offset-skidding="-16">
                                <Icon icon="fa-solid fa-ellipsis-vertical" class="text-xl"></Icon>
                            </button>
                        </th>
                        <th scope="col" class="w-60 p-4 md:w-auto">Raised Form</th>
                        <th scope="col" class="w-60 md:w-auto">Raised At</th>
                        <th scope="col" class="w-60 md:w-auto">Form Template</th>
                        <th scope="col" class="w-40 md:w-auto">Action</th>
                    </tr>
                </thead>
                <tbody>
                    <!-- Table rows -->
                    <tr class="bg-white dark:border-light-700 hover:bg-light-50 dark:hover:bg-orange-200"
                        v-for="raisedForm in raisedForms.data">
                        <td class="mb-5 p-4" v-if="currentUser.role.delete_raised_form">
                            <div class="flex items-center">
                                <input type="checkbox" class="checkbox" :value="raisedForm.id"
                                    v-model="selectionForm.selected" />
                            </div>
                        </td>
                        <td class="mb-5 p-4 dark:text-black">
                            {{ raisedForm.name }}
                        </td>
                        <td class="mb-5 dark:text-black">
                            {{ new Date(raisedForm.created_at).toLocaleString() }}
                        </td>
                        <td class="mb-5 dark:text-black">
                            {{ raisedForm.form_template.name }}
                        </td>
                        <td class="mb-5 flex items-center mt-5">
                            <Link v-if="currentUser.can_raise_forms" :href="`/form/raisedForm/${raisedForm.id}/edit`"
                                class="font-medium dark:text-green-500 hover:underline">
                            <Icon icon="fa-solid fa-pen-to-square" class="text-2xl"></Icon>
                            </Link>

                            <div class="mx-3"></div>
                        
                        <button  @click=" deleteRaisedForm(raisedForm.id)" v-if="currentUser.role.delete_user">
                             <Icon icon="fa-trash-can" class="text-xl cursor-pointer"></Icon>
                        </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        
    </div>
   

    <!-- Dropdown menu -->
    <div id="dropdown-table"
        class="z-10 hidden bg-white divide-y divide-gray-100 shadow-md border border-gray-300 w-44 dark:bg-gray-700">
        <ul class="py-2 text-sm text-gray-700 dark:text-gray-200" aria-labelledby="dropdownDefaultButton">
            <li>
                <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="
                        selectionForm.selected = raisedForms.data.map(
                            (raisedForm) => raisedForm.id
                        )
                        ">
                    Select All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0"
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="selectionForm.selected = []">
                    Deselect All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0" @click="deleteRaisedForm"
                    class="w-full text-start block px-4 py-2 hover:bg-red-100 disabled:opacity-50 disabled:hover:bg-white dark:hover:bg-gray-600 dark:hover:text-white text-red-500">
                    Delete
                    <span v-if="selectionForm.selected.length">({{ selectionForm.selected.length }})</span>
                </button>
            </li>
        </ul>
    </div>

    <Pagination :data="raisedForms"></Pagination>
</template>
<script setup>
import { computed, onMounted } from "vue";
import { Link, useForm, usePage } from "@inertiajs/vue3";
import Pagination from "@/Components/Pagination.vue";
import { initDropdowns } from "flowbite";

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
    raisedForms: Object,
});

onMounted(() => {
    initDropdowns();
});

//selection
const selectionForm = useForm({
    selected: [],
});

function deleteRaisedForm(formId) {
    if (confirm("Are you sure to delete?")) {
        selectionForm.selected.push(formId);
        selectionForm.delete("/form/raisedForm", {
            preserveScroll: true,
            preserveState: false,
        });
    }
}


</script>
